<?php
/**
*
* This file is part of the ning2phpbb hack.
* The code is partially derived from the phpbb code.
* @package ning2phpbb
* @copyright (c) 2010 phpBB Group, Alain Vagner
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/*
* the goal of this file is to send a new password to all users after the migration
*/

// init
include(dirname(__FILE__).'/import-config.php');
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'includes/functions_display.' . $phpEx);
$user->session_begin();
$auth->acl($user->data);
include($phpbb_root_path . 'includes/functions_user.' . $phpEx);
include_once($phpbb_root_path . 'includes/functions_messenger.' . $phpEx);

// code adapted from includes/ucp/ucp_remind.php

$sql = 'SELECT user_id, username, user_permissions, user_email, user_jabber, user_notify_type, user_type, user_lang, user_inactive_reason
	FROM ' . USERS_TABLE;
$result = $db->sql_query($sql);

while ($user_row = $db->sql_fetchrow($result)) {

	if (!$user_row)
	{
		echo 'no_email_user<br />';
		continue;
		//trigger_error('NO_EMAIL_USER');
	}

	if ($user_row['user_type'] == USER_IGNORE)
	{
		// in a default phpbb installation there are lots of these users (crawlers, etc.)
		// so there is no need to warn the user
		continue;
	}

	if ($user_row['user_type'] == USER_INACTIVE)
	{
		if ($user_row['user_inactive_reason'] == INACTIVE_MANUAL)
		{
			echo 'ACCOUNT_DEACTIVATED<br />';
			continue;
			//trigger_error('ACCOUNT_DEACTIVATED');
		}
		else
		{
			echo 'ACCOUNT_NOT_ACTIVATED<br />';
			continue;	
			//trigger_error('ACCOUNT_NOT_ACTIVATED');
		}
	}

	// Check users permissions
	$auth2 = new auth();
	$auth2->acl($user_row);

	if (!$auth2->acl_get('u_chgpasswd'))
	{
		echo 'NO_AUTH_PASSWORD_REMINDER<br />';
		continue;	
		//trigger_error('NO_AUTH_PASSWORD_REMINDER');
	}

	$server_url = generate_board_url();

	$key_len = 54 - strlen($server_url);
	$key_len = max(6, $key_len); // we want at least 6
	$key_len = ($config['max_pass_chars']) ? min($key_len, $config['max_pass_chars']) : $key_len; // we want at most $config['max_pass_chars']
	$user_actkey = substr(gen_rand_string(10), 0, $key_len);
	$user_password = gen_rand_string(8);

	$sql = 'UPDATE ' . USERS_TABLE . "
		SET user_newpasswd = '" . $db->sql_escape(phpbb_hash($user_password)) . "', user_actkey = '" . $db->sql_escape($user_actkey) . "'
		WHERE user_id = " . $user_row['user_id'];
	$db->sql_query($sql);
	
	$messenger = new messenger(false);

	$messenger->template('user_ning_migration', $user_row['user_lang']);

	$messenger->to($user_row['user_email'], $user_row['username']);
	$messenger->im($user_row['user_jabber'], $user_row['username']);

	$messenger->assign_vars(array(
		'USERNAME'		=> htmlspecialchars_decode($user_row['username']),
		'PASSWORD'		=> htmlspecialchars_decode($user_password),
		'U_ACTIVATE'	=> "$server_url/ucp.$phpEx?mode=activate&u={$user_row['user_id']}&k=$user_actkey")
	);

	$messenger->send($user_row['user_notify_type']);
}
$db->sql_freeresult($result);

?>
